// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Bounce : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkBounceU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkBounceU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_bounceAddressW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkBounceU_bounceAddressW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_bounceDataW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkBounceU_bounceDataW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_getBounceTypeW", CharSet = CharSet.Unicode)]
        private static extern int CkBounceU_getBounceTypeW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_debugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkBounceU_debugLogFilePathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_putDebugLogFilePathW", CharSet = CharSet.Unicode)]
        private static extern void CkBounceU_putDebugLogFilePathW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_lastErrorHtmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkBounceU_lastErrorHtmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_lastErrorTextW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkBounceU_lastErrorTextW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_lastErrorXmlW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkBounceU_lastErrorXmlW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkBounceU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkBounceU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_getVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern int CkBounceU_getVerboseLoggingW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_putVerboseLoggingW", CharSet = CharSet.Unicode)]
        private static extern void CkBounceU_putVerboseLoggingW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_versionW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkBounceU_versionW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_ExamineEmailW", CharSet = CharSet.Unicode)]
        private static extern int CkBounceU_ExamineEmailW(System.IntPtr pObj, System.IntPtr email);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_ExamineEmlW", CharSet = CharSet.Unicode)]
        private static extern int CkBounceU_ExamineEmlW(System.IntPtr pObj, string emlFilename);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_ExamineMimeW", CharSet = CharSet.Unicode)]
        private static extern int CkBounceU_ExamineMimeW(System.IntPtr pObj, string mimeText);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_SaveLastErrorW", CharSet = CharSet.Unicode)]
        private static extern int CkBounceU_SaveLastErrorW(System.IntPtr pObj, string path);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkBounceU_UnlockComponentW", CharSet = CharSet.Unicode)]
        private static extern int CkBounceU_UnlockComponentW(System.IntPtr pObj, string unlockCode);


		public Bounce()
		{
			m_pObj = CkBounceU_CreateW();
			m_needDisposal = true;
		}

		public Bounce(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkBounceU_DisposeW(p);
			}
		}

		~Bounce()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Bounce
	/// <summary>
	/// The bounced email address when a bounced email is recognized.
	/// </summary>
	public string BounceAddress
	{
		get
		{
			return ckFromUni(CkBounceU_bounceAddressW(m_pObj));
		}
	}

	/// <summary>
	/// The raw body of the bounced mail.
	/// </summary>
	public string BounceData
	{
		get
		{
			return ckFromUni(CkBounceU_bounceDataW(m_pObj));
		}
	}

	/// <summary>
	/// A number representing the type of bounce that was recognized.
	/// A value of 0 indicates "No Bounce". Other values are:
	/// 
	/// 1. Hard Bounce. The email could not be delivered and BounceAddress contains the
	/// failed email address.
	/// 2. Soft Bounce. A temporary condition exists causing the email delivery to fail.
	/// The BounceAddress property contains the failed email address.
	/// 3. General Bounced Mail, cannot determine if it is hard or soft, and the email
	/// address is not available.
	/// 4. General Bounced Mail, cannot determine if it is hard or soft, but an email
	/// address is available.
	/// 5. Mail Block. A bounce occured because the sender was blocked.
	/// 6. Auto-Reply/Out-of-Office email.
	/// 7. Transient message, such as "Delivery Status / No Action Required".
	/// 8. Subscribe request.
	/// 9. Unsubscribe request.
	/// 10. Virus email notification.
	/// 11. Suspected Bounce, but no other information is available
	/// 12. Challenge/Response - Auto-reply message sent by SPAM software where only
	/// verified email addresses are accepted.
	/// 13. Address Change Notification Messages.
	/// 14. Success DSN indicating that the message was successfully relayed.
	/// 15. Abuse/fraud feedback report.
	/// </summary>
	public int BounceType
	{
		get
		{
			return CkBounceU_getBounceTypeW(m_pObj);
		}
	}

	/// <summary>
	/// If set to a file path, causes each Chilkat method or property call to
	/// automatically append it's LastErrorText to the specified log file. The
	/// information is appended such that if a hang or crash occurs, it is possible to
	/// see the context in which the problem occurred, as well as a history of all
	/// Chilkat calls up to the point of the problem. The VerboseLogging property can be
	/// set to provide more detailed information.
	/// 
	/// This property is typically used for debugging the rare cases where a Chilkat
	/// method call hangs or generates an exception that halts program execution (i.e.
	/// crashes). A hang or crash should generally never happen. The typical causes of a
	/// hang are:
	///     a timeout related property was set to 0 to explicitly indicate that an
	///     infinite timeout is desired,
	///     the hang is actually a hang within an event callback (i.e. it is a hang
	///     within the application code), or
	///     there is an internal problem (bug) in the Chilkat code that causes the hang.
	/// 
	///
	/// </summary>
	public string DebugLogFilePath
	{
		get
		{
			return ckFromUni(CkBounceU_debugLogFilePathW(m_pObj));
		}
		set
		{
			CkBounceU_putDebugLogFilePathW(m_pObj, value);
		}
	}

	/// <summary>
	/// Provides information in HTML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorHtml
	{
		get
		{
			return ckFromUni(CkBounceU_lastErrorHtmlW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in plain-text format about the last method/property called.
	/// If a method call returns a value indicating failure, or behaves unexpectedly,
	/// examine this property to get more information.
	/// </summary>
	public string LastErrorText
	{
		get
		{
			return ckFromUni(CkBounceU_lastErrorTextW(m_pObj));
		}
	}

	/// <summary>
	/// Provides information in XML format about the last method/property called. If a
	/// method call returns a value indicating failure, or behaves unexpectedly, examine
	/// this property to get more information.
	/// </summary>
	public string LastErrorXml
	{
		get
		{
			return ckFromUni(CkBounceU_lastErrorXmlW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkBounceU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkBounceU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to true, then the contents of LastErrorText (or LastErrorXml, or
	/// LastErrorHtml) may contain more verbose information. The default value is
	/// false. Verbose logging should only be used for debugging. The potentially
	/// large quantity of logged information may adversely affect peformance.
	/// </summary>
	public bool VerboseLogging
	{
		get
		{
			return (CkBounceU_getVerboseLoggingW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkBounceU_putVerboseLoggingW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Version of the component/library, such as "9.5.0.63"
	/// </summary>
	public string Version
	{
		get
		{
			return ckFromUni(CkBounceU_versionW(m_pObj));
		}
	}

	/// <summary>
	/// Examines an email and sets the properties (BounceType, BounceAddress,
	/// BounceData) according to how the email is classified. This feature can only be
	/// used if Chilkat Mail is downloaded and installed, and it also requires Chilkat
	/// Mail to be licensed in addition to Chilkat Bounce.
	/// </summary>
	public bool ExamineEmail(Email email)
	{
		int result = CkBounceU_ExamineEmailW(m_pObj, email == null ? System.IntPtr.Zero : email.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Examines an email from a .eml file and sets the properties (BounceType,
	/// BounceAddress, BounceData) according to how the email is classified.
	/// </summary>
	public bool ExamineEml(string emlFilename)
	{
		int result = CkBounceU_ExamineEmlW(m_pObj, emlFilename);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Examines an email represented as raw MIME text and sets the properties
	/// (BounceType, BounceAddress, BounceData) according to how the email is
	/// classified. The return value is 1 for a successful classification, or 0 for a
	/// failure.
	/// </summary>
	public bool ExamineMime(string mimeText)
	{
		int result = CkBounceU_ExamineMimeW(m_pObj, mimeText);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Saves the last-error information (the contents of LastErrorXml) to an XML
	/// formatted file.
	/// </summary>
	public bool SaveLastError(string path)
	{
		int result = CkBounceU_SaveLastErrorW(m_pObj, path);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Unlocks the component. This must be called once at the beginning of your program
	/// to unlock the component. A purchased unlock code is provided when the Bounce
	/// component is licensed.
	/// 
	/// A purchased unlock code for the bounce component/library will included the
	/// substring "BOUNCE", or can be a Bundle unlock code.
	/// 
	///
	/// </summary>
	public bool UnlockComponent(string unlockCode)
	{
		int result = CkBounceU_UnlockComponentW(m_pObj, unlockCode);
		return result == 0 ? false : true;
	}


	}
}

