// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Hashtable : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkHashtableU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkHashtableU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkHashtableU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_AddFromXmlSbW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_AddFromXmlSbW(System.IntPtr pObj, System.IntPtr sbXml);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_AddIntW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_AddIntW(System.IntPtr pObj, string key, int value);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_AddQueryParamsW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_AddQueryParamsW(System.IntPtr pObj, string queryParams);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_AddStrW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_AddStrW(System.IntPtr pObj, string key, string value);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_ClearW", CharSet = CharSet.Unicode)]
        private static extern void CkHashtableU_ClearW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_ClearWithNewCapacityW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_ClearWithNewCapacityW(System.IntPtr pObj, int capacity);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_ContainsW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_ContainsW(System.IntPtr pObj, string key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_ContainsIntKeyW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_ContainsIntKeyW(System.IntPtr pObj, int key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_GetKeysW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_GetKeysW(System.IntPtr pObj, System.IntPtr strTable);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_LookupIntW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_LookupIntW(System.IntPtr pObj, string key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_lookupStrW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkHashtableU_lookupStrW(System.IntPtr pObj, string key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_RemoveW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_RemoveW(System.IntPtr pObj, string key);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkHashtableU_ToXmlSbW", CharSet = CharSet.Unicode)]
        private static extern int CkHashtableU_ToXmlSbW(System.IntPtr pObj, System.IntPtr sbXml);


		public Hashtable()
		{
			m_pObj = CkHashtableU_CreateW();
			m_needDisposal = true;
		}

		public Hashtable(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkHashtableU_DisposeW(p);
			}
		}

		~Hashtable()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Hashtable
	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkHashtableU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkHashtableU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Adds to the hash table from XML previously created by calling ToXmlSb.
	/// </summary>
	public bool AddFromXmlSb(StringBuilder sbXml)
	{
		int result = CkHashtableU_AddFromXmlSbW(m_pObj, sbXml == null ? System.IntPtr.Zero : sbXml.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Adds or replaces an entry with the given key and integer value to the hash
	/// table. Returns true if a new hash entry was added or replaced. Returns false
	/// if an out-of-memory condition occurred.
	/// </summary>
	public bool AddInt(string key, int value)
	{
		int result = CkHashtableU_AddIntW(m_pObj, key, value);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Adds URL query parameters into the hashtable. The queryParams has the form:
	/// "field1=value1&amp;field2=value2&amp;field3=value3...". It is assumed that the values
	/// are URL encoded, and this method automatically URL decodes the values prior to
	/// inserting into the hashtable.
	/// </summary>
	public bool AddQueryParams(string queryParams)
	{
		int result = CkHashtableU_AddQueryParamsW(m_pObj, queryParams);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Adds or replaces an entry with the given key and string value to the hash table.
	/// Returns true if a new hash entry was added or replaced. Returns false if an
	/// out-of-memory condition occurred.
	/// </summary>
	public bool AddStr(string key, string value)
	{
		int result = CkHashtableU_AddStrW(m_pObj, key, value);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Removes all elements from the Hashtable.
	/// </summary>
	public void Clear()
	{
		CkHashtableU_ClearW(m_pObj);
		return;
	}
	/// <summary>
	/// Removes all elements from the Hashtable and re-sizes with the specified capacity.
	/// 
	/// The capacity is the number of buckets in the hash table. In the case of a "hash
	/// collision", a single bucket stores multiple entries, which must be searched
	/// sequentially. One rule of thumb is to set the capacity to twice the number of
	/// expected items to be hashed. It's also preferable to set the capacity to a prime
	/// number. (The 1st 10,000 prime numbers are listed here:
	/// https://primes.utm.edu/lists/small/10000.txt )
	/// 
	/// The initial default capacity of the hash table is 521.
	/// 
	///
	/// </summary>
	public bool ClearWithNewCapacity(int capacity)
	{
		int result = CkHashtableU_ClearWithNewCapacityW(m_pObj, capacity);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Determines if a given key is contained within the hash table. Returns true if
	/// the key exists, otherwise returns false.
	/// </summary>
	public bool Contains(string key)
	{
		int result = CkHashtableU_ContainsW(m_pObj, key);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Determines if a given key is contained within the hash table. Returns true if
	/// the key exists, otherwise returns false.
	/// </summary>
	public bool ContainsIntKey(int key)
	{
		int result = CkHashtableU_ContainsIntKeyW(m_pObj, key);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Appends the complete set of hashtable key strings to strTable.
	/// </summary>
	public bool GetKeys(StringTable strTable)
	{
		int result = CkHashtableU_GetKeysW(m_pObj, strTable == null ? System.IntPtr.Zero : strTable.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the integer value associated with the specified key. If the key is not
	/// in the hash table, the return value is 0.
	/// </summary>
	public int LookupInt(string key)
	{
		int result = CkHashtableU_LookupIntW(m_pObj, key);
		return result;
	}
	/// <summary>
	/// Returns the string value associated with the specified key.
	/// </summary>
	public string LookupStr(string key)
	{
		System.IntPtr result = CkHashtableU_lookupStrW(m_pObj, key);
		return ckFromUni(result);
	}
	/// <summary>
	/// Removes the entry with the specified key from the hash table. Returns true if
	/// the key existed and was removed. Returns false if the key did not already
	/// exist.
	/// </summary>
	public bool Remove(string key)
	{
		int result = CkHashtableU_RemoveW(m_pObj, key);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Serializes the hash table to XML format. The XML is appended to sbXml.
	/// </summary>
	public bool ToXmlSb(StringBuilder sbXml)
	{
		int result = CkHashtableU_ToXmlSbW(m_pObj, sbXml == null ? System.IntPtr.Zero : sbXml.getImpl());
		return result == 0 ? false : true;
	}


	}
}

