// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Mailboxes : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkMailboxesU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkMailboxesU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_getCountW", CharSet = CharSet.Unicode)]
        private static extern int CkMailboxesU_getCountW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkMailboxesU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkMailboxesU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_getFlagsW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkMailboxesU_getFlagsW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_GetMailboxIndexW", CharSet = CharSet.Unicode)]
        private static extern int CkMailboxesU_GetMailboxIndexW(System.IntPtr pObj, string mbxName);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_getNameW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkMailboxesU_getNameW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_getNthFlagW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkMailboxesU_getNthFlagW(System.IntPtr pObj, int index, int flagIndex);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_GetNumFlagsW", CharSet = CharSet.Unicode)]
        private static extern int CkMailboxesU_GetNumFlagsW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_HasFlagW", CharSet = CharSet.Unicode)]
        private static extern int CkMailboxesU_HasFlagW(System.IntPtr pObj, int index, string flagName);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_HasInferiorsW", CharSet = CharSet.Unicode)]
        private static extern int CkMailboxesU_HasInferiorsW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_IsMarkedW", CharSet = CharSet.Unicode)]
        private static extern int CkMailboxesU_IsMarkedW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_IsSelectableW", CharSet = CharSet.Unicode)]
        private static extern int CkMailboxesU_IsSelectableW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMailboxesU_LoadTaskResultW", CharSet = CharSet.Unicode)]
        private static extern int CkMailboxesU_LoadTaskResultW(System.IntPtr pObj, System.IntPtr task);


		public Mailboxes()
		{
			m_pObj = CkMailboxesU_CreateW();
			m_needDisposal = true;
		}

		public Mailboxes(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkMailboxesU_DisposeW(p);
			}
		}

		~Mailboxes()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Mailboxes
	/// <summary>
	/// The number of mailboxes in the collection.
	/// 
	/// Note: The Mailboxes class is for use with the Chilkat IMAP component.
	/// 
	///
	/// </summary>
	public int Count
	{
		get
		{
			return CkMailboxesU_getCountW(m_pObj);
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkMailboxesU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkMailboxesU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Returns a comma-separated list of flags for the Nth mailbox. For example,
	/// "\HasNoChildren,\Important".
	/// </summary>
	public string GetFlags(int index)
	{
		System.IntPtr result = CkMailboxesU_getFlagsW(m_pObj, index);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the index of the mailbox having the specified name.
	/// </summary>
	public int GetMailboxIndex(string mbxName)
	{
		int result = CkMailboxesU_GetMailboxIndexW(m_pObj, mbxName);
		return result;
	}
	/// <summary>
	/// The name of the Nth mailbox in this collection. Indexing begins at 0.
	/// </summary>
	public string GetName(int index)
	{
		System.IntPtr result = CkMailboxesU_getNameW(m_pObj, index);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the name of the Nth flag for the Mth mailbox. The index is the index of
	/// the mailbox. The flagIndex is the index of the flag.
	/// </summary>
	public string GetNthFlag(int index, int flagIndex)
	{
		System.IntPtr result = CkMailboxesU_getNthFlagW(m_pObj, index, flagIndex);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the number of flags for the Nth mailbox. Returns -1 if the index is out
	/// of range.
	/// </summary>
	public int GetNumFlags(int index)
	{
		int result = CkMailboxesU_GetNumFlagsW(m_pObj, index);
		return result;
	}
	/// <summary>
	/// Returns true if the Nth mailbox has the specified flag set. The flag name is
	/// case insensitive and should begin with a backslash character, such as
	/// "\Flagged". The index is the index of the Nth mailbox.
	/// </summary>
	public bool HasFlag(int index, string flagName)
	{
		int result = CkMailboxesU_HasFlagW(m_pObj, index, flagName);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns true if the Nth mailbox has inferiors (i.e. sub-mailboxes), or if it
	/// is possible to create child mailboxes in the future.
	/// 
	/// Note: the HasNoChildren attribute/flag should not be confused with the IMAP4
	/// [RFC-2060] defined attribute Noinferiors which indicates that no child mailboxes
	/// exist now AND none can be created in the future.
	/// 
	///
	/// </summary>
	public bool HasInferiors(int index)
	{
		int result = CkMailboxesU_HasInferiorsW(m_pObj, index);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns true if the Nth mailbox is marked.
	/// </summary>
	public bool IsMarked(int index)
	{
		int result = CkMailboxesU_IsMarkedW(m_pObj, index);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns true if the Nth mailbox is selectable.
	/// </summary>
	public bool IsSelectable(int index)
	{
		int result = CkMailboxesU_IsSelectableW(m_pObj, index);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads the mailboxes object from a completed asynchronous task.
	/// </summary>
	public bool LoadTaskResult(Task task)
	{
		int result = CkMailboxesU_LoadTaskResultW(m_pObj, task == null ? System.IntPtr.Zero : task.getImpl());
		return result == 0 ? false : true;
	}


	}
}

