// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class MessageSet : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkMessageSetU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkMessageSetU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_getCountW", CharSet = CharSet.Unicode)]
        private static extern int CkMessageSetU_getCountW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_getHasUidsW", CharSet = CharSet.Unicode)]
        private static extern int CkMessageSetU_getHasUidsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_putHasUidsW", CharSet = CharSet.Unicode)]
        private static extern void CkMessageSetU_putHasUidsW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkMessageSetU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkMessageSetU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_ContainsIdW", CharSet = CharSet.Unicode)]
        private static extern int CkMessageSetU_ContainsIdW(System.IntPtr pObj, int msgId);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_FromCompactStringW", CharSet = CharSet.Unicode)]
        private static extern int CkMessageSetU_FromCompactStringW(System.IntPtr pObj, string str);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_GetIdW", CharSet = CharSet.Unicode)]
        private static extern int CkMessageSetU_GetIdW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_InsertIdW", CharSet = CharSet.Unicode)]
        private static extern void CkMessageSetU_InsertIdW(System.IntPtr pObj, int id);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_LoadTaskResultW", CharSet = CharSet.Unicode)]
        private static extern int CkMessageSetU_LoadTaskResultW(System.IntPtr pObj, System.IntPtr task);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_RemoveIdW", CharSet = CharSet.Unicode)]
        private static extern void CkMessageSetU_RemoveIdW(System.IntPtr pObj, int id);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_toCommaSeparatedStrW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkMessageSetU_toCommaSeparatedStrW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkMessageSetU_toCompactStringW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkMessageSetU_toCompactStringW(System.IntPtr pObj);


		public MessageSet()
		{
			m_pObj = CkMessageSetU_CreateW();
			m_needDisposal = true;
		}

		public MessageSet(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkMessageSetU_DisposeW(p);
			}
		}

		~MessageSet()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = MessageSet
	/// <summary>
	/// The number of message UIDs (or sequence numbers) in this message set.
	/// </summary>
	public int Count
	{
		get
		{
			return CkMessageSetU_getCountW(m_pObj);
		}
	}

	/// <summary>
	/// If true then the message set contains UIDs, otherwise it contains sequence
	/// numbers.
	/// </summary>
	public bool HasUids
	{
		get
		{
			return (CkMessageSetU_getHasUidsW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkMessageSetU_putHasUidsW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkMessageSetU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkMessageSetU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Returns true if the msgId is contained in the message set.
	/// </summary>
	public bool ContainsId(int msgId)
	{
		int result = CkMessageSetU_ContainsIdW(m_pObj, msgId);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Loads the message set from a compact-string representation. Here are some
	/// examples:
	/// 
	/// Non-Compact String
	/// 
	/// Compact String
	/// 
	/// 1,2,3,4,5
	/// 
	/// 1:5
	/// 
	/// 1,2,3,4,5,8,9,10
	/// 
	/// 1:5,8:10
	/// 
	/// 1,3,4,5,8,9,10
	/// 
	/// 1,3:5,8:10
	/// 
	///
	/// </summary>
	public bool FromCompactString(string str)
	{
		int result = CkMessageSetU_FromCompactStringW(m_pObj, str);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the message ID of the Nth message in the set. (indexing begins at 0).
	/// Returns -1 if the index is out of range.
	/// </summary>
	public int GetId(int index)
	{
		int result = CkMessageSetU_GetIdW(m_pObj, index);
		return result;
	}
	/// <summary>
	/// Inserts a message ID into the set. If the ID already exists, a duplicate is not
	/// inserted.
	/// </summary>
	public void InsertId(int id)
	{
		CkMessageSetU_InsertIdW(m_pObj, id);
		return;
	}
	/// <summary>
	/// Loads the message set from a completed asynchronous task.
	/// </summary>
	public bool LoadTaskResult(Task task)
	{
		int result = CkMessageSetU_LoadTaskResultW(m_pObj, task == null ? System.IntPtr.Zero : task.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Removes a message ID from the set.
	/// </summary>
	public void RemoveId(int id)
	{
		CkMessageSetU_RemoveIdW(m_pObj, id);
		return;
	}
	/// <summary>
	/// Returns a string of comma-separated message IDs. (This is the non-compact string
	/// format.)
	/// </summary>
	public string ToCommaSeparatedStr()
	{
		System.IntPtr result = CkMessageSetU_toCommaSeparatedStrW(m_pObj);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the set of message IDs represented as a compact string. Here are some
	/// examples:
	/// 
	/// Non-Compact String
	/// 
	/// Compact String
	/// 
	/// 1,2,3,4,5
	/// 
	/// 1:5
	/// 
	/// 1,2,3,4,5,8,9,10
	/// 
	/// 1:5,8:10
	/// 
	/// 1,3,4,5,8,9,10
	/// 
	/// 1,3:5,8:10
	/// 
	///
	/// </summary>
	public string ToCompactString()
	{
		System.IntPtr result = CkMessageSetU_toCompactStringW(m_pObj);
		return ckFromUni(result);
	}


	}
}

