// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class SFtpDir : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkSFtpDirU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkSFtpDirU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkSFtpDirU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkSFtpDirU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSFtpDirU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkSFtpDirU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSFtpDirU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkSFtpDirU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSFtpDirU_getNumFilesAndDirsW", CharSet = CharSet.Unicode)]
        private static extern int CkSFtpDirU_getNumFilesAndDirsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSFtpDirU_originalPathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSFtpDirU_originalPathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSFtpDirU_getFilenameW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSFtpDirU_getFilenameW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSFtpDirU_GetFileObjectW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSFtpDirU_GetFileObjectW(System.IntPtr pObj, int index);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSFtpDirU_LoadTaskResultW", CharSet = CharSet.Unicode)]
        private static extern int CkSFtpDirU_LoadTaskResultW(System.IntPtr pObj, System.IntPtr task);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSFtpDirU_SortW", CharSet = CharSet.Unicode)]
        private static extern void CkSFtpDirU_SortW(System.IntPtr pObj, string field, int ascending);


		public SFtpDir()
		{
			m_pObj = CkSFtpDirU_CreateW();
			m_needDisposal = true;
		}

		public SFtpDir(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkSFtpDirU_DisposeW(p);
			}
		}

		~SFtpDir()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = SFtpDir
	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkSFtpDirU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkSFtpDirU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// The number of entries in this directory listing.
	/// </summary>
	public int NumFilesAndDirs
	{
		get
		{
			return CkSFtpDirU_getNumFilesAndDirsW(m_pObj);
		}
	}

	/// <summary>
	/// The original path used to fetch this directory listing. This is the string that
	/// was originally passed to the OpenDir method when the directory was read.
	/// </summary>
	public string OriginalPath
	{
		get
		{
			return ckFromUni(CkSFtpDirU_originalPathW(m_pObj));
		}
	}

	/// <summary>
	/// Returns the Nth filename in the directory (indexing begins at 0).
	/// </summary>
	public string GetFilename(int index)
	{
		System.IntPtr result = CkSFtpDirU_getFilenameW(m_pObj, index);
		return ckFromUni(result);
	}
	/// <summary>
	/// Returns the Nth entry in the directory. Indexing begins at 0.
	/// </summary>
	public SFtpFile GetFileObject(int index)
	{
		System.IntPtr result = CkSFtpDirU_GetFileObjectW(m_pObj, index);
		if (result == IntPtr.Zero) return null;
		return new SFtpFile(result);
	}
	/// <summary>
	/// Loads the SFTP directory object from a completed asynchronous task.
	/// </summary>
	public bool LoadTaskResult(Task task)
	{
		int result = CkSFtpDirU_LoadTaskResultW(m_pObj, task == null ? System.IntPtr.Zero : task.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Sorts the files and sub-directories in ascending or descending order based on
	/// the field. Possible values for field are "filename", "filenameNoCase",
	/// "lastModifiedTime", "lastAccessTime", "lastCreateTime", or "size". (For
	/// case-insensitive filename sorting, use "filenameNoCase".)
	/// </summary>
	public void Sort(string field, bool ascending)
	{
		CkSFtpDirU_SortW(m_pObj, field, ascending == false ? 0 : 1);
		return;
	}


	}
}

