// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class SecureString : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkSecureStringU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkSecureStringU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkSecureStringU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkSecureStringU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_maintainHashW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSecureStringU_maintainHashW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_putMaintainHashW", CharSet = CharSet.Unicode)]
        private static extern void CkSecureStringU_putMaintainHashW(System.IntPtr pObj, string newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_getReadOnlyW", CharSet = CharSet.Unicode)]
        private static extern int CkSecureStringU_getReadOnlyW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_putReadOnlyW", CharSet = CharSet.Unicode)]
        private static extern void CkSecureStringU_putReadOnlyW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_accessW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSecureStringU_accessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_AppendW", CharSet = CharSet.Unicode)]
        private static extern int CkSecureStringU_AppendW(System.IntPtr pObj, string str);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_AppendSbW", CharSet = CharSet.Unicode)]
        private static extern int CkSecureStringU_AppendSbW(System.IntPtr pObj, System.IntPtr sb);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_AppendSecureW", CharSet = CharSet.Unicode)]
        private static extern int CkSecureStringU_AppendSecureW(System.IntPtr pObj, System.IntPtr secStr);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_hashValW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkSecureStringU_hashValW(System.IntPtr pObj, string encoding);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_LoadFileW", CharSet = CharSet.Unicode)]
        private static extern int CkSecureStringU_LoadFileW(System.IntPtr pObj, string path, string charset);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_SecStrEqualsW", CharSet = CharSet.Unicode)]
        private static extern int CkSecureStringU_SecStrEqualsW(System.IntPtr pObj, System.IntPtr secStr);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkSecureStringU_VerifyHashW", CharSet = CharSet.Unicode)]
        private static extern int CkSecureStringU_VerifyHashW(System.IntPtr pObj, string hashVal, string encoding);


		public SecureString()
		{
			m_pObj = CkSecureStringU_CreateW();
			m_needDisposal = true;
		}

		public SecureString(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkSecureStringU_DisposeW(p);
			}
		}

		~SecureString()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = SecureString
	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkSecureStringU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkSecureStringU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If set to the name of a hash algorithm, then a hash of the current string value
	/// is maintained. This allows for the hash to be verified via the VerifyHash
	/// method. Possible hash algorithm names are "sha1", "sha256", "sha384", "sha512",
	/// "md5", "md2", "ripemd160", "ripemd128","ripemd256", and "ripemd320".
	/// </summary>
	public string MaintainHash
	{
		get
		{
			return ckFromUni(CkSecureStringU_maintainHashW(m_pObj));
		}
		set
		{
			CkSecureStringU_putMaintainHashW(m_pObj, value);
		}
	}

	/// <summary>
	/// Can be set to true to make this secure string read-only (cannot be modified).
	/// </summary>
	public bool ReadOnly
	{
		get
		{
			return (CkSecureStringU_getReadOnlyW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkSecureStringU_putReadOnlyW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// Returns the clear-text string value.
	/// </summary>
	public string Access()
	{
		System.IntPtr result = CkSecureStringU_accessW(m_pObj);
		return ckFromUni(result);
	}
	/// <summary>
	/// Appends a clear-text string to this secure string. The in-memory data will be
	/// decrypted, the string will be appended, and then it will be re-encrypted. Can
	/// return false if the string has been marked as read-only via the ReadOnly
	/// property.
	/// </summary>
	public bool Append(string str)
	{
		int result = CkSecureStringU_AppendW(m_pObj, str);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Appends a clear-text string contained in a StringBuilder to this secure string.
	/// The in-memory data will be decrypted, the string will be appended, and then it
	/// will be re-encrypted. Can return false if the string has been marked as
	/// read-only via the ReadOnly property.
	/// </summary>
	public bool AppendSb(StringBuilder sb)
	{
		int result = CkSecureStringU_AppendSbW(m_pObj, sb == null ? System.IntPtr.Zero : sb.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Appends the contents of a secure string to this secure string. The in-memory
	/// data will be decrypted, the secure string will be appended, and then it will be
	/// re-encrypted. Can return false if this string has been marked as read-only via
	/// the ReadOnly property.
	/// </summary>
	public bool AppendSecure(SecureString secStr)
	{
		int result = CkSecureStringU_AppendSecureW(m_pObj, secStr == null ? System.IntPtr.Zero : secStr.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns the hash value for the current value of this secure string. The encoding
	/// specifies the encoding to be used. It can be any of the binary encoding
	/// algorithms, such as "base64", "hex", and many more listed atChilkat Binary
	/// Encodings
	/// &lt;http://cknotes.com/chilkat-binary-encoding-list/&gt;
	/// </summary>
	public string HashVal(string encoding)
	{
		System.IntPtr result = CkSecureStringU_hashValW(m_pObj, encoding);
		return ckFromUni(result);
	}
	/// <summary>
	/// Loads the contents of a file into this secure string. The current contents of
	/// this object are replaced with the new text from the file.
	/// </summary>
	public bool LoadFile(string path, string charset)
	{
		int result = CkSecureStringU_LoadFileW(m_pObj, path, charset);
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Returns true if the secStr equals the contents of this secure string.
	/// </summary>
	public bool SecStrEquals(SecureString secStr)
	{
		int result = CkSecureStringU_SecStrEqualsW(m_pObj, secStr == null ? System.IntPtr.Zero : secStr.getImpl());
		return result == 0 ? false : true;
	}
	/// <summary>
	/// Verifies the hashVal against the hash value stored for the current value of this
	/// secure string. The MaintainHash property must've previously been set for this
	/// secure string to maintain an internal hash. The encoding specifies the encoding of
	/// the hashVal. It can be any of the binary encoding algorithms, such as "base64",
	/// "hex", and many more listed atChilkat Binary Encodings
	/// &lt;http://cknotes.com/chilkat-binary-encoding-list/&gt;
	/// </summary>
	public bool VerifyHash(string hashVal, string encoding)
	{
		int result = CkSecureStringU_VerifyHashW(m_pObj, hashVal, encoding);
		return result == 0 ? false : true;
	}


	}
}

