// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class ServerSentEvent : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkServerSentEventU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkServerSentEventU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkServerSentEventU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkServerSentEventU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkServerSentEventU_dataW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkServerSentEventU_dataW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkServerSentEventU_eventNameW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkServerSentEventU_eventNameW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkServerSentEventU_lastEventIdW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkServerSentEventU_lastEventIdW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkServerSentEventU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkServerSentEventU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkServerSentEventU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkServerSentEventU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkServerSentEventU_getRetryW", CharSet = CharSet.Unicode)]
        private static extern int CkServerSentEventU_getRetryW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkServerSentEventU_LoadEventW", CharSet = CharSet.Unicode)]
        private static extern int CkServerSentEventU_LoadEventW(System.IntPtr pObj, string eventText);


		public ServerSentEvent()
		{
			m_pObj = CkServerSentEventU_CreateW();
			m_needDisposal = true;
		}

		public ServerSentEvent(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkServerSentEventU_DisposeW(p);
			}
		}

		~ServerSentEvent()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = ServerSentEvent
	/// <summary>
	/// The data for the server-side event. (If the "data" field was empty, then this
	/// will be empty.)
	/// </summary>
	public string Data
	{
		get
		{
			return ckFromUni(CkServerSentEventU_dataW(m_pObj));
		}
	}

	/// <summary>
	/// The name of the server-side event. (If the "event" field was not present, then
	/// this will be empty.)
	/// </summary>
	public string EventName
	{
		get
		{
			return ckFromUni(CkServerSentEventU_eventNameW(m_pObj));
		}
	}

	/// <summary>
	/// The content of the "id" field, if present.
	/// </summary>
	public string LastEventId
	{
		get
		{
			return ckFromUni(CkServerSentEventU_lastEventIdW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkServerSentEventU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkServerSentEventU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// The integer value of the "retry" field, if present. Otherwise 0.
	/// </summary>
	public int Retry
	{
		get
		{
			return CkServerSentEventU_getRetryW(m_pObj);
		}
	}

	/// <summary>
	/// Loads the multi-line event text into this object. For example, the eventText for a
	/// Firebase event might look like this:
	/// event: put
	/// data: {"path": "/c", "data": {"foo": true, "bar": false}}
	///
	/// </summary>
	public bool LoadEvent(string eventText)
	{
		int result = CkServerSentEventU_LoadEventW(m_pObj, eventText);
		return result == 0 ? false : true;
	}


	}
}

