// Generated for Chilkat v9.5.0.90
using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace Chilkat
{
	public class Url : CkObject
	{
		private bool m_needDisposal = false;
		private System.IntPtr m_pObj;

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_CreateW", CharSet = CharSet.Unicode)]
		private static extern System.IntPtr CkUrlU_CreateW();

		[DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_DisposeW", CharSet = CharSet.Unicode)]
		private static extern void CkUrlU_DisposeW(System.IntPtr pObj);

        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_fragW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkUrlU_fragW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_hostW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkUrlU_hostW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_hostTypeW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkUrlU_hostTypeW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_getLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern int CkUrlU_getLastMethodSuccessW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_putLastMethodSuccessW", CharSet = CharSet.Unicode)]
        private static extern void CkUrlU_putLastMethodSuccessW(System.IntPtr pObj, int newVal);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_loginW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkUrlU_loginW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_passwordW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkUrlU_passwordW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_pathW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkUrlU_pathW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_pathWithQueryParamsW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkUrlU_pathWithQueryParamsW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_getPortW", CharSet = CharSet.Unicode)]
        private static extern int CkUrlU_getPortW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_queryW", CharSet = CharSet.Unicode)]
        private static extern System.IntPtr CkUrlU_queryW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_getSslW", CharSet = CharSet.Unicode)]
        private static extern int CkUrlU_getSslW(System.IntPtr pObj);
        [DllImport(ChilkatConst.DllPath, EntryPoint = "CkUrlU_ParseUrlW", CharSet = CharSet.Unicode)]
        private static extern int CkUrlU_ParseUrlW(System.IntPtr pObj, string url);


		public Url()
		{
			m_pObj = CkUrlU_CreateW();
			m_needDisposal = true;
		}

		public Url(System.IntPtr p)
		{
			m_pObj = p;
			m_needDisposal = true;
		}

		override protected void disposeUnmanaged()
		{
			if (m_needDisposal)
			{
				m_needDisposal = false;
				System.IntPtr p = m_pObj;
				m_pObj = System.IntPtr.Zero;
				CkUrlU_DisposeW(p);
			}
		}

		~Url()
		{
			disposeUnmanaged();
		}

		public System.IntPtr getImpl()
		{
			return  m_pObj;
		}

		// This class does not have events.
		// dnClassName = Url
	/// <summary>
	/// Contains any text following a fragment marker (#) in the URL, excluding the
	/// fragment marker. Given the URI http://www.contoso.com/index.htm#main, the
	/// fragment is "main".
	/// </summary>
	public string Frag
	{
		get
		{
			return ckFromUni(CkUrlU_fragW(m_pObj));
		}
	}

	/// <summary>
	/// The DNS host name or IP address part of the URL. For example, if the URL is
	/// "http://www.contoso.com:8080/", the Host is "www.contoso.com". If the URL is
	/// "https://192.168.1.124/test.html", the Host is "192.168.1.124".
	/// </summary>
	public string Host
	{
		get
		{
			return ckFromUni(CkUrlU_hostW(m_pObj));
		}
	}

	/// <summary>
	/// The type of the host name specified in the URL. Possible values are:
	///     "dns": The host name is a domain name system (DNS) style host name.
	///     "ipv4": The host name is an Internet Protocol (IP) version 4 host address.
	///     "ipv6": The host name is an Internet Protocol (IP) version 6 host address.
	///
	/// </summary>
	public string HostType
	{
		get
		{
			return ckFromUni(CkUrlU_hostTypeW(m_pObj));
		}
	}

	/// <summary>
	/// Indicate whether the last method call succeeded or failed. A value of true
	/// indicates success, a value of false indicates failure. This property is
	/// automatically set for method calls. It is not modified by property accesses. The
	/// property is automatically set to indicate success for the following types of
	/// method calls:
	///     Any method that returns a string.
	///     Any method returning a Chilkat object, binary bytes, or a date/time.
	///     Any method returning a standard boolean status value where success = true
	///     and failure = false.
	///     Any method returning an integer where failure is defined by a return value
	///     less than zero.
	/// 
	/// Note: Methods that do not fit the above requirements will always set this
	/// property equal to true. For example, a method that returns no value (such as a
	/// "void" in C++) will technically always succeed.
	/// 
	///
	/// </summary>
	public bool LastMethodSuccess
	{
		get
		{
			return (CkUrlU_getLastMethodSuccessW(m_pObj) != 0) ? true : false;
		}
		set
		{
			CkUrlU_putLastMethodSuccessW(m_pObj, value ? 1 : 0);
		}
	}

	/// <summary>
	/// If the URL contains a login and password, this is the login part. For example,
	/// if the URL is "http://user:password@www.contoso.com/index.htm ", then the login
	/// is "user".
	/// </summary>
	public string Login
	{
		get
		{
			return ckFromUni(CkUrlU_loginW(m_pObj));
		}
	}

	/// <summary>
	/// If the URL contains a login and password, this is the password part. For
	/// example, if the URL is "http://user:password@www.contoso.com/index.htm ", then
	/// the password is "password".
	/// </summary>
	public string Password
	{
		get
		{
			return ckFromUni(CkUrlU_passwordW(m_pObj));
		}
	}

	/// <summary>
	/// The path (and params) part of the URL, excluding the query and fragment. If the
	/// URL is:
	/// "http://www.amazon.com/gp/product/1476752842/ref=s9_psimh_gw_p14_d0_i3?pf_rd_m=AT
	/// VPDKIKX0DER&amp;pf_rd_s=desktop-1", then the path is
	/// "/gp/product/1476752842/ref=s9_psimh_gw_p14_d0_i3".
	/// </summary>
	public string Path
	{
		get
		{
			return ckFromUni(CkUrlU_pathW(m_pObj));
		}
	}

	/// <summary>
	/// The path (and params) part of the URL, including the query params, but excluding
	/// the fragment. If the URL is:
	/// "http://www.amazon.com/gp/product/1476752842/ref=s9_psimh_gw_p14_d0_i3?pf_rd_m=AT
	/// VPDKIKX0DER&amp;pf_rd_s=desktop-1", then then this property returns
	/// "/gp/product/1476752842/ref=s9_psimh_gw_p14_d0_i3?pf_rd_m=ATVPDKIKX0DER&amp;pf_rd_s=d
	/// esktop-1".
	/// </summary>
	public string PathWithQueryParams
	{
		get
		{
			return ckFromUni(CkUrlU_pathWithQueryParamsW(m_pObj));
		}
	}

	/// <summary>
	/// The port number of the URL.
	/// 
	/// For example, if the URL is "http://www.contoso.com:8080/", the port number is
	/// 8080.
	/// If the URL is "https://192.168.1.124/test.html", the port number is the default
	/// 80.
	/// If the URL is "https://www.amazon.com/", the port number is the default SSL/TLS
	/// port 443.
	/// 
	///
	/// </summary>
	public int Port
	{
		get
		{
			return CkUrlU_getPortW(m_pObj);
		}
	}

	/// <summary>
	/// The query part of the URL, excluding the fragment. If the URL is:
	/// "http://www.amazon.com/gp/product/1476752842/ref=s9_psimh_gw_p14_d0_i3?pf_rd_m=AT
	/// VPDKIKX0DER&amp;pf_rd_s=desktop-1#frag", then the query is
	/// "pf_rd_m=ATVPDKIKX0DER&amp;pf_rd_s=desktop-1".
	/// </summary>
	public string Query
	{
		get
		{
			return ckFromUni(CkUrlU_queryW(m_pObj));
		}
	}

	/// <summary>
	/// true if the URL indicates SSL/TLS, otherwise false. A URL beginning with
	/// "https://" indicates SSL/TLS.
	/// </summary>
	public bool Ssl
	{
		get
		{
			return (CkUrlU_getSslW(m_pObj) != 0) ? true : false;
		}
	}

	/// <summary>
	/// Parses a full URL. After parsing, the various parts of the URL are available iin
	/// the properties.
	/// </summary>
	public bool ParseUrl(string url)
	{
		int result = CkUrlU_ParseUrlW(m_pObj, url);
		return result == 0 ? false : true;
	}


	}
}

